/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"time"
)

// checks if the TimestampTrait type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TimestampTrait{}

// TimestampTrait struct for TimestampTrait
type TimestampTrait struct {
	CreatedAt NullableTime `json:"createdAt,omitempty"`
}

// NewTimestampTrait instantiates a new TimestampTrait object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTimestampTrait() *TimestampTrait {
	this := TimestampTrait{}
	return &this
}

// NewTimestampTraitWithDefaults instantiates a new TimestampTrait object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTimestampTraitWithDefaults() *TimestampTrait {
	this := TimestampTrait{}
	return &this
}

// GetCreatedAt returns the CreatedAt field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *TimestampTrait) GetCreatedAt() time.Time {
	if o == nil || IsNil(o.CreatedAt.Get()) {
		var ret time.Time
		return ret
	}
	return *o.CreatedAt.Get()
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *TimestampTrait) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return o.CreatedAt.Get(), o.CreatedAt.IsSet()
}

// HasCreatedAt returns a boolean if a field has been set.
func (o *TimestampTrait) HasCreatedAt() bool {
	if o != nil && o.CreatedAt.IsSet() {
		return true
	}

	return false
}

// SetCreatedAt gets a reference to the given NullableTime and assigns it to the CreatedAt field.
func (o *TimestampTrait) SetCreatedAt(v time.Time) {
	o.CreatedAt.Set(&v)
}

// SetCreatedAtNil sets the value for CreatedAt to be an explicit nil
func (o *TimestampTrait) SetCreatedAtNil() {
	o.CreatedAt.Set(nil)
}

// UnsetCreatedAt ensures that no value is present for CreatedAt, not even an explicit nil
func (o *TimestampTrait) UnsetCreatedAt() {
	o.CreatedAt.Unset()
}

func (o TimestampTrait) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TimestampTrait) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.CreatedAt.IsSet() {
		toSerialize["createdAt"] = o.CreatedAt.Get()
	}
	return toSerialize, nil
}

type NullableTimestampTrait struct {
	value *TimestampTrait
	isSet bool
}

func (v NullableTimestampTrait) Get() *TimestampTrait {
	return v.value
}

func (v *NullableTimestampTrait) Set(val *TimestampTrait) {
	v.value = val
	v.isSet = true
}

func (v NullableTimestampTrait) IsSet() bool {
	return v.isSet
}

func (v *NullableTimestampTrait) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTimestampTrait(val *TimestampTrait) *NullableTimestampTrait {
	return &NullableTimestampTrait{value: val, isSet: true}
}

func (v NullableTimestampTrait) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTimestampTrait) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
